#ifndef __SUBMARINE_ERRORS_H
#define __SUBMARINE_ERRORS_H

#ifdef __cplusplus
extern "C" {
#endif

#define SUB_ASSERT_CRITICAL 1
#define SUB_ASSERT_NON_CRITICAL 0

void submarine_assert_func(int assert_num, int is_critical);

#define SUB_ASSERT(expr, assert_num, critical) \
    do { \
        if (expr) { \
            submarine_assert_func(assert_num, critical); \
        } \
    } while (0)

/* !!! BEWARE !!! DO NOT CHANGE THE ORDER! */
typedef enum {
    SUB_INIT_CLOCK_ASSERT_0 = 0,  /* Init clock asserts */
    SUB_INIT_CLOCK_ASSERT_1,
    SUB_UNUSED_ASSERT_2,
    SUB_UNUSED_ASSERT_3,
    SUB_UNUSED_ASSERT_4,

    SUB_INIT_I2C1_ASSERT_5 = 5, /* Init i2c1 asserts */
    SUB_UNUSED_ASSERT_6,
    SUB_UNUSED_ASSERT_7,
    SUB_UNUSED_ASSERT_8,
    SUB_UNUSED_ASSERT_9,

    SUB_INIT_TIM2_ASSERT_10 = 10, /* Init timer2 asserts */
    SUB_INIT_TIM2_ASSERT_11,
    SUB_INIT_TIM2_ASSERT_12,
    SUB_INIT_TIM2_ASSERT_13,
    SUB_UNUSED_ASSERT_14,

    SUB_INIT_TIM5_ASSERT_15 = 15, /* Init timer5 asserts */
    SUB_INIT_TIM5_ASSERT_16,
    SUB_INIT_TIM5_ASSERT_17,
    SUB_UNUSED_ASSERT_18,
    SUB_UNUSED_ASSERT_19,

    SUB_INIT_TIM9_ASSERT_20 = 20, /* Init timer9 asserts */
    SUB_INIT_TIM9_ASSERT_21,
    SUB_UNUSED_ASSERT_22,
    SUB_UNUSED_ASSERT_23,
    SUB_UNUSED_ASSERT_24,

    SUB_INIT_UART1_ASSERT_25 = 25, /* Init uart1 asserts */
    SUB_UNUSED_ASSERT_26,
    SUB_UNUSED_ASSERT_27,
    SUB_UNUSED_ASSERT_28,
    SUB_UNUSED_ASSERT_29,

    SUB_INIT_UART6_ASSERT_30 = 30,  /* Init uart6 asserts */
    SUB_UNUSED_ASSERT_31,
    SUB_UNUSED_ASSERT_32,
    SUB_UNUSED_ASSERT_33,
    SUB_UNUSED_ASSERT_34,

    SUB_INIT_TIM3_ASSERT_35 = 35, /* Init TIM3 asserts */
    SUB_INIT_TIM3_ASSERT_36,
    SUB_UNUSED_ASSERT_37,
    SUB_UNUSED_ASSERT_38,
    SUB_UNUSED_ASSERT_39,

    SUB_INIT_DMA2_STREAM2_ASSERT_40 = 40, /* Init DMA2 stream2 asserts */
    SUB_UNUSED_ASSERT_41,
    SUB_UNUSED_ASSERT_42,
    SUB_UNUSED_ASSERT_43,
    SUB_UNUSED_ASSERT_44,

    SUB_UNUSED_ASSERT_45 = 45,
    SUB_UNUSED_ASSERT_46,
    SUB_UNUSED_ASSERT_47,
    SUB_UNUSED_ASSERT_48,
    SUB_UNUSED_ASSERT_49,

    SUB_UNUSED_ASSERT_50 = 50,
    SUB_UNUSED_ASSERT_51,
    SUB_UNUSED_ASSERT_52,
    SUB_UNUSED_ASSERT_53,
    SUB_UNUSED_ASSERT_54,

    SUB_UNUSED_ASSERT_55 = 55,
    SUB_UNUSED_ASSERT_56,
    SUB_UNUSED_ASSERT_57,
    SUB_UNUSED_ASSERT_58,
    SUB_UNUSED_ASSERT_59,

    SUB_DIVING_PISTON_RANGE_SENSOR_ASSERT_60 = 60,
    SUB_DIVING_PISTON_RANGE_SENSOR_ASSERT_61,
    SUB_DIVING_PISTON_RANGE_SENSOR_ASSERT_62,
    SUB_DIVING_PISTON_RANGE_I2C_LL_ASSERT_63,
    SUB_UNUSED_ASSERT_64,

    /* place above some initialization asserts if needed */

    SUB_SENSORS_DATA_COLLECTOR_THREAD_ASSERT_1000 = 1000,
    SUB_UNUSED_ASSERT_1001,
    SUB_UNUSED_ASSERT_1002,
    SUB_UNUSED_ASSERT_1003,
    SUB_UNUSED_ASSERT_1004,

    SUB_TF_MINI_S_ASSERT_1005 = 1005, /* laser depth sensor asserts */
    SUB_TF_MINI_S_ASSERT_1006,
    SUB_UNUSED_ASSERT_1007,
    SUB_UNUSED_ASSERT_1008,
    SUB_UNUSED_ASSERT_1009,

    REMOTE_INIT_CLOCK_ASSERT_10000 = 10000, /* Remote init clock */
    REMOTE_INIT_CLOCK_ASSERT_10001,
    REMOTE_INIT_CLOCK_ASSERT_10002,
    REMOTE_UNUSED_ASSERT_10003,
    REMOTE_UNUSED_ASSERT_10004,

    REMOTE_INIT_ADC1_ASSERT_10005 = 10005, /* Remote init ADC1 */
    REMOTE_INIT_ADC1_ASSERT_10006,
    REMOTE_UNUSED_ASSERT_10007,
    REMOTE_UNUSED_ASSERT_10008,
    REMOTE_UNUSED_ASSERT_10009,

    REMOTE_INIT_SPI1_ASSERT_10010 = 10010, /* Remote init SPI1 */
    REMOTE_UNUSED_ASSERT_10011,
    REMOTE_UNUSED_ASSERT_10012,
    REMOTE_UNUSED_ASSERT_10013,
    REMOTE_UNUSED_ASSERT_10014,

    REMOTE_INIT_UART1_ASSERT_10015 = 10015, /* Remote init UART1 */
    REMOTE_UNUSED_ASSERT_10016,
    REMOTE_UNUSED_ASSERT_10017,
    REMOTE_UNUSED_ASSERT_10018,
    REMOTE_UNUSED_ASSERT_10019,

    REMOTE_INIT_TIM3_ASSERT_10020 = 10020, /* Remote init TIM3 */
    REMOTE_INIT_TIM3_ASSERT_10021,
    REMOTE_UNUSED_ASSERT_10022,
    REMOTE_UNUSED_ASSERT_10023,
    REMOTE_UNUSED_ASSERT_10024,

    REMOTE_UNUSED_ASSERT_10025 = 10025,
    REMOTE_UNUSED_ASSERT_10026,
    REMOTE_UNUSED_ASSERT_10027,
    REMOTE_UNUSED_ASSERT_10028,
    REMOTE_UNUSED_ASSERT_10029,

    REMOTE_UNUSED_ASSERT_10030 = 10030,
    REMOTE_UNUSED_ASSERT_10031,
    REMOTE_UNUSED_ASSERT_10032,
    REMOTE_UNUSED_ASSERT_10033,
    REMOTE_UNUSED_ASSERT_10034,

    REMOTE_UNUSED_ASSERT_10035 = 10035,
    REMOTE_UNUSED_ASSERT_10036,
    REMOTE_UNUSED_ASSERT_10037,
    REMOTE_UNUSED_ASSERT_10038,
    REMOTE_UNUSED_ASSERT_10039,

    REMOTE_UNUSED_ASSERT_10040 = 10040,
    REMOTE_UNUSED_ASSERT_10041,
    REMOTE_UNUSED_ASSERT_10042,
    REMOTE_UNUSED_ASSERT_10043,
    REMOTE_UNUSED_ASSERT_10044,

    REMOTE_UNUSED_ASSERT_10045 = 10045,
    REMOTE_UNUSED_ASSERT_10046,
    REMOTE_UNUSED_ASSERT_10047,
    REMOTE_UNUSED_ASSERT_10048,
    REMOTE_UNUSED_ASSERT_10049,

    REMOTE_UNUSED_ASSERT_10050 = 10050,
    REMOTE_UNUSED_ASSERT_10051,
    REMOTE_UNUSED_ASSERT_10052,
    REMOTE_UNUSED_ASSERT_10053,
    REMOTE_UNUSED_ASSERT_10054,

    REMOTE_UNUSED_ASSERT_10055 = 10055,
    REMOTE_UNUSED_ASSERT_10056,
    REMOTE_UNUSED_ASSERT_10057,
    REMOTE_UNUSED_ASSERT_10058,
    REMOTE_UNUSED_ASSERT_10059,

    REMOTE_UNUSED_ASSERT_10060 = 10060,
    REMOTE_UNUSED_ASSERT_10061,
    REMOTE_UNUSED_ASSERT_10062,
    REMOTE_UNUSED_ASSERT_10063,
    REMOTE_UNUSED_ASSERT_10064,

    REMOTE_BUTTON_THREAD_ASSERT_10065 = 10065,
    REMOTE_UNUSED_ASSERT_10066,
    REMOTE_UNUSED_ASSERT_10067,
    REMOTE_UNUSED_ASSERT_10068,
    REMOTE_UNUSED_ASSERT_10069,

} submarine_errors_t;

#ifdef __cplusplus
}
#endif

#endif /* __SUBMARINE_ERRORS_H */
